package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;

public class TipodeCardapioPage extends PageBase {

    //Mapping
    By ClicarMenu = By.xpath("//i[@class='v-icon notranslate mdi mdi-menu theme--light']");
    By CampodePesquisa = By.id("menuSearchInput");
    By ClicarnaTipodeCardapio = By.xpath("//*[@class='v-list-item__title']");

    By BlocoTipodeCardapio = By.xpath("//div[@id='cardTextTpCard']");
    By AdicionarArvoreTipodeCardapio = By.xpath("//button[@id='addTree']//i[@class='v-icon notranslate mdi mdi-plus theme--light']");
    By NomeTipoCard = By.xpath("//input[@id='NMPASTATCARD']");
    By CampoSalvarTipoCard = By.xpath("//button[@id='saveTpCard']");
    By CampoSelecionarTipodeCardAdicionado = By.xpath("//span[text()='0000000003']");
    By AdicionarTipoCardapio = By.xpath("//div[@id='TIPOCARD-top']//button[@id='addButton']//i[@class='v-icon notranslate mdi mdi-plus theme--light']");
    By CampoCodigo = By.xpath("//input[@id='CDTIPOCARD_editable_']");
    By CampoTipodeCardapio = By.xpath("//input[@id='NMTIPOCARD_editable_']");
    By MarcarTipoCardComoAtivo = By.xpath("//span[@id='IDTPCARDATIV_editable_']");
    By SalvarTipodeCardapio = By.xpath("//div[@id='TIPOCARD-top']//button[@id='saveButton']");

    By ClicarTipoCardpAdicionado = By.xpath("//span[text()='0000000029']");
    By AdicionarConfiguracaoServico = By.xpath("//div[@id='SERVTIPOCARD-top']//i[@class='v-icon notranslate mdi mdi-plus theme--light']");
    By SelecionarServico = By.xpath("//div[text()='00004 | RETIRADA AUTOMATICA']");
    By CampoSalvarConfiguracaoServico = By.xpath("//div[@id='SERVTIPOCARD-top']//button[@id='saveButton']");
    By ConfirmarImportarConfigPadraoCentral = By.xpath("//button[@id='yes']");
    By AbaUnidadePorTipodeCardapio = By.xpath("//div[@id='tabPai-tab-1']//span[@class='zd-tabs-tab-text']");
    By AdicionarUnidade = By.xpath("//div[@id='UNIDADECARD']//button[@id='addButton']");
    By SelecionarUnidade = By.xpath("//div[text()='0002 | DEPOSITO JABAQUARA']");
    By MarcarUnidadeComoAtiva = By.xpath("//span[@id='IDTCARATFILI_editable_']");
    By SalvarUnidadeTipoCard = By.xpath("//div[@id='UNIDADECARD-top']//button[@id='saveButton']");

    By RetornaTipoCardAdicionado = By.xpath("//span[text()='Salvo com sucesso!']");

    By IconeRelatorio = By.xpath("//button[@id='tipoDeCardapioRelatorio']//i[@class='v-icon notranslate mdi mdi-file-document theme--light']");
    By SelecionarServicoRelatorio = By.xpath("//input[@id='SERVICO']");
    By MarcarServico = By.xpath("//div[text()='00004 | RETIRADA AUTOMATICA']");
    By FecharFiltroServico = By.xpath("//button[@class='v-icon notranslate v-icon--link mdi mdi-chevron-down theme--light primary--text']");
    By Clicarnopdf = By.xpath("//button[@id='pdf']//span[@class='v-btn__content']");

    By SelecionarRelatorio = By.xpath("//input[@id='REPORT']");
    By SelecionarRelatTipoCardPorUnidade = By.xpath("//div[text()='Tipo de Cardápio por Unidade']");
    By CampoParaSelecionarAgregada = By.xpath("//input[@id='UNIDADE']");
    By MarcarAgregada = By.xpath("//div[text()='0002 | DEPOSITO JABAQUARA']");
    By FecharCampoFiltroAgregada = By.xpath("//button[@class='v-icon notranslate v-icon--link mdi mdi-chevron-down theme--light primary--text']");
    By SelecionarTipodeCardap = By.xpath("//input[@id='TIPOCARD_RELATORIO']");
    By MarcarOTipoCard = By.xpath("//div[text()='0000000002 | DESJEJUM']");
    By FecharFiltroTipoCard = By.xpath("//button[@class='v-icon notranslate v-icon--link mdi mdi-chevron-down theme--light primary--text']");


    By SelecionarRelatUnidadeporTipoCard = By.xpath("//div[text()='Unidade por Tipo de Cardápio']");
    By BlocoTipodeCardapioPorUnidade = By.xpath("//div[@id='rowCollapse']");
    By CampoAgregada = By.xpath("//input[@id='CDFILIAL']");
    By SelecionarAgregada = By.xpath("//div[text()='0002 | DEPOSITO JABAQUARA']");
    By ClicarparaAdicionarTipoCard = By.xpath("//div[@id='gridTipoCardUnidade-top']//i[@class='v-icon notranslate mdi mdi-plus theme--light']");
    By SelecionarTipodeCardapio = By.xpath("//div[text()='0000000004 | MERENDA']");
    By MarcarTipoCardAtivo = By.xpath("//span[@id='IDTCARATFILI_editable_']//div[@class='v-input--selection-controls__ripple']");
    By SalvarTipoCardUnidade = By.xpath("//div[@id='gridTipoCardUnidade-top']//button[@id='saveButton']");




    //Actions
    public void AcessarTela() {
        tempo();
        click(ClicarMenu);
        sendKeys(CampodePesquisa, "Tipo de Cardápio");
        tempo();
        click(ClicarnaTipodeCardapio);
    }


    public void AdicionarArvoreTipodeCardapio(String arvcardp){
        tempo();
        click(BlocoTipodeCardapio);
        tempo();
        click(AdicionarArvoreTipodeCardapio);
        click(NomeTipoCard);
        sendKeys(NomeTipoCard, arvcardp);
        click(CampoSalvarTipoCard);
        tempo();
    }

    public void AdicionarTipoCardapio(String codigo, String tipocard){
        tempo();
        click(CampoSelecionarTipodeCardAdicionado);
        tempo();
        click(AdicionarTipoCardapio);
        sendKeys(CampoCodigo, codigo);
        click(CampoTipodeCardapio);
        sendKeys(CampoTipodeCardapio, tipocard);
        tempo();
        click(MarcarTipoCardComoAtivo);
        tempo();
        click(SalvarTipodeCardapio);
        tempo();
    }

    public void AdicionarConfigdoServico() {
        tempo();
        click(ClicarTipoCardpAdicionado);
        click(AdicionarConfiguracaoServico);
        tempo();
        click(SelecionarServico);
        tempo();
        click(CampoSalvarConfiguracaoServico);
        tempo();
        click(ConfirmarImportarConfigPadraoCentral);
        tempo();
    }

    public void AdicionarUnidadePorTipodeCardapio(){
        tempo();
        click(AbaUnidadePorTipodeCardapio);
        tempo();
        click(AdicionarUnidade);
        tempo();
        click(SelecionarUnidade);
        click(MarcarUnidadeComoAtiva);
        click(SalvarUnidadeTipoCard);
        tempo();
    }

    public String RetornaMsgSalvoComSucesso(){return getText(RetornaTipoCardAdicionado);}


    public void GerarRelatorioTipodeCardapio(){
        tempo();
        click(BlocoTipodeCardapio);
        click(IconeRelatorio);
        tempo();
        click(SelecionarServicoRelatorio);
        tempo();
        click(MarcarServico);
        tempo();
        click(FecharFiltroServico);
        click(Clicarnopdf);
        tempo();

    }

    public void GerarRelatorioTipoCardUnidade(){
        tempo();
        click(BlocoTipodeCardapio);
        click(IconeRelatorio);
        tempo();
        click(SelecionarRelatorio);
        click(SelecionarRelatUnidadeporTipoCard);
        click(CampoParaSelecionarAgregada);
        click(MarcarAgregada);
        click(FecharCampoFiltroAgregada);
        tempo();
        click(SelecionarTipodeCardap);
        click(MarcarOTipoCard);
        click(FecharFiltroTipoCard);
        tempo();
        click(Clicarnopdf);
        tempo();

    }

    public void GerarRelatorioUnidadeTipoCard(){
        tempo();
        click(BlocoTipodeCardapio);
        click(IconeRelatorio);
        tempo();
        click(SelecionarRelatorio);
        click(SelecionarRelatTipoCardPorUnidade);
        click(CampoParaSelecionarAgregada);
        click(MarcarAgregada);
        click(FecharCampoFiltroAgregada);
        tempo();
        click(SelecionarTipodeCardap);
        click(MarcarOTipoCard);
        click(FecharFiltroTipoCard);
        tempo();
        click(Clicarnopdf);
        tempo();

    }

    public void AdicionarTipoCardAgregada(){
        tempo();
        click(BlocoTipodeCardapioPorUnidade);
        tempo();
        click(CampoAgregada);
        click(SelecionarAgregada);
        tempo();
        click(ClicarparaAdicionarTipoCard);
        click(SelecionarTipodeCardapio);
        click(MarcarTipoCardAtivo);
        click(SalvarTipoCardUnidade);
        tempo();

    }


}
